summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-10-02 11:10:22 +0200
committerJim Meyering <jim@meyering.net>2007-10-02 11:20:19 +0200
commit1b8c8befd96bb1ebf02eeade5029a81e1b6c4dc1 (patch)
treedafaac59ecd7202330dfe333b1eae0f75687bb18 /tests/cp
parent65ee3d963014a4c93dcf17886a7da2a8c43277b2 (diff)
downloadcoreutils-1b8c8befd96bb1ebf02eeade5029a81e1b6c4dc1.tar.xz
Never copy through a symlink that cp has just created.
* src/copy.c (copy_internal): When same-file detection requires 'stat'ing the destination file, also 'lstat' it and ensure that it wasn't the destination of a preceding copy operation. This bug was introduced on 2007-06-18. * tests/cp/abuse: New test for the above. * tests/cp/Makefile.am (TESTS): Add abuse.
Diffstat (limited to 'tests/cp')
-rw-r--r--tests/cp/Makefile.am1
-rwxr-xr-xtests/cp/abuse57
2 files changed, 58 insertions, 0 deletions
diff --git a/tests/cp/Makefile.am b/tests/cp/Makefile.am
index 074f5f6f6..83e2126de 100644
--- a/tests/cp/Makefile.am
+++ b/tests/cp/Makefile.am
@@ -16,6 +16,7 @@
# along with this program. If not, see <http://www.gnu.org/licenses/>.
TESTS = \
+ abuse \
proc-zero-len \
thru-dangling \
cp-a-selinux \
diff --git a/tests/cp/abuse b/tests/cp/abuse
new file mode 100755
index 000000000..04b10f7f6
--- /dev/null
+++ b/tests/cp/abuse
@@ -0,0 +1,57 @@
+#!/bin/sh
+# ensure that cp does not write through a just-copied symlink
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+. $srcdir/../test-lib.sh
+
+mkdir a b c || framework_failure
+ln -s ../t a/1 || framework_failure
+echo payload > b/1 || framework_failure
+
+echo "cp: will not copy \`b/1' through just-created symlink \`c/1'" \
+ > exp || framework_failure
+
+# Check both cases: a dangling symlink, and one pointing to a writable file.
+
+fail=0
+for i in dangling-dest existing-dest; do
+ test $i = existing-dest && echo i > t
+ test $i = dangling-dest && rm -f t
+
+ cp -a a/1 b/1 c 2> out && fail=1
+
+ compare out exp || fail=1
+
+ # When the destination is a dangling symlink,
+ # ensure that cp does not create it.
+ test $i = dangling-dest \
+ && test -f t && fail=1
+
+ # When the destination symlink points to a writable file,
+ # ensure that cp does not change it.
+ test $i = existing-dest \
+ && case $(cat t) in i);; *) fail=1;; esac
+done
+
+(exit $fail); exit $fail